Index: drivers/filesystems/btrfs/flushthread.c
===================================================================
--- drivers/filesystems/btrfs/flushthread.c	(révision 75772)
+++ drivers/filesystems/btrfs/flushthread.c	(copie de travail)
@@ -3476,22 +4054,23 @@
         de->length = c->chunk_item->size / factor;
         de->chunktree_uuid = Vcb->chunk_root->treeholder.tree->header.chunk_tree_uuid;
 
-        if (!insert_tree_item(Vcb, Vcb->dev_root, c->devices[i]->devitem.dev_id, TYPE_DEV_EXTENT, cis[i].offset, de, sizeof(DEV_EXTENT), NULL, Irp, rollback)) {
-            ERR("insert_tree_item failed\n");
+        Status = insert_tree_item(Vcb, Vcb->dev_root, c->devices[i]->devitem.dev_id, TYPE_DEV_EXTENT, cis[i].offset, de, sizeof(DEV_EXTENT), NULL, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item returned %08x\n", Status);
             ExFreePool(de);
-            return STATUS_INTERNAL_ERROR;
+            return Status;
         }
-        
+
         // FIXME - no point in calling this twice for the same device
-        Status = update_dev_item(Vcb, c->devices[i], Irp, rollback);
+        Status = update_dev_item(Vcb, c->devices[i], Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("update_dev_item returned %08x\n", Status);
             return Status;
         }
     }
-    
+
     c->created = FALSE;
-    
+
     return STATUS_SUCCESS;
 }
 
@@ -3502,158 +4081,106 @@
     le = Vcb->sys_chunks.Flink;
     while (le != &Vcb->sys_chunks) {
         sc2 = CONTAINING_RECORD(le, sys_chunk, list_entry);
-        
+
         if (sc2->key.obj_id == obj_id && sc2->key.obj_type == obj_type && sc2->key.offset == offset) {
             RemoveEntryList(&sc2->list_entry);
-            
+
             Vcb->superblock.n -= sizeof(KEY) + sc2->size;
-            
+
             ExFreePool(sc2->data);
             ExFreePool(sc2);
             regen_bootstrap(Vcb);
             return;
         }
-        
+
         le = le->Flink;
     }
 }
 
-static NTSTATUS STDCALL set_xattr(device_extension* Vcb, LIST_ENTRY* batchlist, root* subvol, UINT64 inode, char* name, UINT32 crc32,
-                                  UINT8* data, UINT16 datalen, PIRP Irp, LIST_ENTRY* rollback) {
-    ULONG xasize;
+static NTSTATUS set_xattr(device_extension* Vcb, LIST_ENTRY* batchlist, root* subvol, UINT64 inode, char* name, UINT16 namelen,
+                          UINT32 crc32, UINT8* data, UINT16 datalen) {
+    NTSTATUS Status;
+    UINT16 xasize;
     DIR_ITEM* xa;
-    
-    TRACE("(%p, %llx, %llx, %s, %08x, %p, %u)\n", Vcb, subvol->id, inode, name, crc32, data, datalen);
-    
-    xasize = sizeof(DIR_ITEM) - 1 + (ULONG)strlen(name) + datalen;
-    
+
+    TRACE("(%p, %llx, %llx, %.*s, %08x, %p, %u)\n", Vcb, subvol->id, inode, namelen, name, crc32, data, datalen);
+
+    xasize = (UINT16)offsetof(DIR_ITEM, name[0]) + namelen + datalen;
+
     xa = ExAllocatePoolWithTag(PagedPool, xasize, ALLOC_TAG);
     if (!xa) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     xa->key.obj_id = 0;
     xa->key.obj_type = 0;
     xa->key.offset = 0;
     xa->transid = Vcb->superblock.generation;
     xa->m = datalen;
-    xa->n = (UINT16)strlen(name);
+    xa->n = namelen;
     xa->type = BTRFS_TYPE_EA;
-    RtlCopyMemory(xa->name, name, strlen(name));
-    RtlCopyMemory(xa->name + strlen(name), data, datalen);
-    
-    if (!insert_tree_item_batch(batchlist, Vcb, subvol, inode, TYPE_XATTR_ITEM, crc32, xa, xasize, Batch_SetXattr, Irp, rollback))
-        return STATUS_INTERNAL_ERROR;
-    
+    RtlCopyMemory(xa->name, name, namelen);
+    RtlCopyMemory(xa->name + namelen, data, datalen);
+
+    Status = insert_tree_item_batch(batchlist, Vcb, subvol, inode, TYPE_XATTR_ITEM, crc32, xa, xasize, Batch_SetXattr);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item_batch returned %08x\n", Status);
+        ExFreePool(xa);
+        return Status;
+    }
+
     return STATUS_SUCCESS;
 }
 
-static BOOL STDCALL delete_xattr(device_extension* Vcb, root* subvol, UINT64 inode, char* name, UINT32 crc32, PIRP Irp, LIST_ENTRY* rollback) {
-    KEY searchkey;
-    traverse_ptr tp;
+static NTSTATUS delete_xattr(device_extension* Vcb, LIST_ENTRY* batchlist, root* subvol, UINT64 inode, char* name,
+                             UINT16 namelen, UINT32 crc32) {
+    NTSTATUS Status;
+    UINT16 xasize;
     DIR_ITEM* xa;
-    NTSTATUS Status;
-    
-    TRACE("(%p, %llx, %llx, %s, %08x)\n", Vcb, subvol->id, inode, name, crc32);
-    
-    searchkey.obj_id = inode;
-    searchkey.obj_type = TYPE_XATTR_ITEM;
-    searchkey.offset = crc32;
-    
-    Status = find_item(Vcb, subvol, &tp, &searchkey, FALSE, Irp);
-    if (!NT_SUCCESS(Status)) {
-        ERR("error - find_item returned %08x\n", Status);
-        return FALSE;
+
+    TRACE("(%p, %llx, %llx, %.*s, %08x)\n", Vcb, subvol->id, inode, namelen, name, crc32);
+
+    xasize = (UINT16)offsetof(DIR_ITEM, name[0]) + namelen;
+
+    xa = ExAllocatePoolWithTag(PagedPool, xasize, ALLOC_TAG);
+    if (!xa) {
+        ERR("out of memory\n");
+        return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
-    if (!keycmp(tp.item->key, searchkey)) { // key exists
-        ULONG size = tp.item->size;
-        
-        if (tp.item->size < sizeof(DIR_ITEM)) {
-            ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(DIR_ITEM));
-            
-            return FALSE;
-        } else {
-            xa = (DIR_ITEM*)tp.item->data;
-            
-            while (TRUE) {
-                ULONG oldxasize;
-                
-                if (size < sizeof(DIR_ITEM) || size < sizeof(DIR_ITEM) - 1 + xa->m + xa->n) {
-                    ERR("(%llx,%x,%llx) was truncated\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset);
-                        
-                    return FALSE;
-                }
-                
-                oldxasize = sizeof(DIR_ITEM) - 1 + xa->m + xa->n;
-                
-                if (xa->n == strlen(name) && RtlCompareMemory(name, xa->name, xa->n) == xa->n) {
-                    ULONG newsize;
-                    UINT8 *newdata, *dioff;
-                    
-                    newsize = tp.item->size - (sizeof(DIR_ITEM) - 1 + xa->n + xa->m);
-                    
-                    delete_tree_item(Vcb, &tp, rollback);
-                    
-                    if (newsize == 0) {
-                        TRACE("xattr %s deleted\n", name);
-                        
-                        return TRUE;
-                    }
 
-                    // FIXME - deleting collisions almost certainly works, but we should test it properly anyway
-                    newdata = ExAllocatePoolWithTag(PagedPool, newsize, ALLOC_TAG);
-                    if (!newdata) {
-                        ERR("out of memory\n");
-                        return FALSE;
-                    }
+    xa->key.obj_id = 0;
+    xa->key.obj_type = 0;
+    xa->key.offset = 0;
+    xa->transid = Vcb->superblock.generation;
+    xa->m = 0;
+    xa->n = namelen;
+    xa->type = BTRFS_TYPE_EA;
+    RtlCopyMemory(xa->name, name, namelen);
 
-                    if ((UINT8*)xa > tp.item->data) {
-                        RtlCopyMemory(newdata, tp.item->data, (UINT8*)xa - tp.item->data);
-                        dioff = newdata + ((UINT8*)xa - tp.item->data);
-                    } else {
-                        dioff = newdata;
-                    }
-                    
-                    if ((UINT8*)&xa->name[xa->n+xa->m] - tp.item->data < tp.item->size)
-                        RtlCopyMemory(dioff, &xa->name[xa->n+xa->m], tp.item->size - ((UINT8*)&xa->name[xa->n+xa->m] - tp.item->data));
-                    
-                    insert_tree_item(Vcb, subvol, inode, TYPE_XATTR_ITEM, crc32, newdata, newsize, NULL, Irp, rollback);
-                    
-                        
-                    return TRUE;
-                }
-                
-                if (xa->m + xa->n >= size) { // FIXME - test this works
-                    WARN("xattr %s not found\n", name);
+    Status = insert_tree_item_batch(batchlist, Vcb, subvol, inode, TYPE_XATTR_ITEM, crc32, xa, xasize, Batch_DeleteXattr);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item_batch returned %08x\n", Status);
+        ExFreePool(xa);
+        return Status;
+    }
 
-                    return FALSE;
-                } else {
-                    xa = (DIR_ITEM*)&xa->name[xa->m + xa->n];
-                    size -= oldxasize;
-                }
-            }
-        }
-    } else {
-        WARN("xattr %s not found\n", name);
-        
-        return FALSE;
-    }
+    return STATUS_SUCCESS;
 }
 
-static NTSTATUS insert_sparse_extent(fcb* fcb, UINT64 start, UINT64 length, PIRP Irp, LIST_ENTRY* rollback) {
+static NTSTATUS insert_sparse_extent(fcb* fcb, LIST_ENTRY* batchlist, UINT64 start, UINT64 length) {
+    NTSTATUS Status;
     EXTENT_DATA* ed;
     EXTENT_DATA2* ed2;
-    
+
     TRACE("((%llx, %llx), %llx, %llx)\n", fcb->subvol->id, fcb->inode, start, length);
-    
+
     ed = ExAllocatePoolWithTag(PagedPool, sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2), ALLOC_TAG);
     if (!ed) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     ed->generation = fcb->Vcb->superblock.generation;
     ed->decoded_size = length;
     ed->compression = BTRFS_COMPRESSION_NONE;
@@ -3660,57 +4187,63 @@
     ed->encryption = BTRFS_ENCRYPTION_NONE;
     ed->encoding = BTRFS_ENCODING_NONE;
     ed->type = EXTENT_TYPE_REGULAR;
-    
+
     ed2 = (EXTENT_DATA2*)ed->data;
     ed2->address = 0;
     ed2->size = 0;
     ed2->offset = 0;
     ed2->num_bytes = length;
-    
-    if (!insert_tree_item(fcb->Vcb, fcb->subvol, fcb->inode, TYPE_EXTENT_DATA, start, ed, sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2), NULL, Irp, rollback)) {
-        ERR("insert_tree_item failed\n");
-        return STATUS_INTERNAL_ERROR;
+
+    Status = insert_tree_item_batch(batchlist, fcb->Vcb, fcb->subvol, fcb->inode, TYPE_EXTENT_DATA, start, ed, sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2), Batch_Insert);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item_batch returned %08x\n", Status);
+        ExFreePool(ed);
+        return Status;
     }
 
     return STATUS_SUCCESS;
 }
 
-static BOOL insert_tree_item_batch(LIST_ENTRY* batchlist, device_extension* Vcb, root* r, UINT64 objid, UINT64 objtype, UINT64 offset,
-                                   void* data, UINT16 datalen, enum batch_operation operation, PIRP Irp, LIST_ENTRY* rollback) {
+#ifdef _MSC_VER
+#pragma warning(push)
+#pragma warning(suppress: 28194)
+#endif
+NTSTATUS insert_tree_item_batch(LIST_ENTRY* batchlist, device_extension* Vcb, root* r, UINT64 objid, UINT8 objtype, UINT64 offset,
+                                _In_opt_ _When_(return >= 0, __drv_aliasesMem) void* data, UINT16 datalen, enum batch_operation operation) {
     LIST_ENTRY* le;
     batch_root* br = NULL;
     batch_item* bi;
-    
+
     le = batchlist->Flink;
     while (le != batchlist) {
         batch_root* br2 = CONTAINING_RECORD(le, batch_root, list_entry);
-        
+
         if (br2->r == r) {
             br = br2;
             break;
         }
-        
+
         le = le->Flink;
     }
-    
+
     if (!br) {
         br = ExAllocatePoolWithTag(PagedPool, sizeof(batch_root), ALLOC_TAG);
         if (!br) {
             ERR("out of memory\n");
-            return FALSE;
+            return STATUS_INSUFFICIENT_RESOURCES;
         }
-        
+
         br->r = r;
         InitializeListHead(&br->items);
         InsertTailList(batchlist, &br->list_entry);
     }
-    
+
     bi = ExAllocateFromPagedLookasideList(&Vcb->batch_item_lookaside);
     if (!bi) {
         ERR("out of memory\n");
-        return FALSE;
+        return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     bi->key.obj_id = objid;
     bi->key.obj_type = objtype;
     bi->key.offset = offset;
@@ -3717,23 +4250,26 @@
     bi->data = data;
     bi->datalen = datalen;
     bi->operation = operation;
-    
+
     le = br->items.Blink;
     while (le != &br->items) {
         batch_item* bi2 = CONTAINING_RECORD(le, batch_item, list_entry);
-        
+
         if (keycmp(bi2->key, bi->key) != 1) {
             InsertHeadList(&bi2->list_entry, &bi->list_entry);
-            return TRUE;
+            return STATUS_SUCCESS;
         }
-        
+
         le = le->Blink;
     }
-    
+
     InsertHeadList(&br->items, &bi->list_entry);
-    
-    return TRUE;
+
+    return STATUS_SUCCESS;
 }
+#ifdef _MSC_VER
+#pragma warning(pop)
+#endif
 
 typedef struct {
     UINT64 address;
@@ -3746,29 +4282,29 @@
     LIST_ENTRY list_entry;
 } extent_range;
 
-static void rationalize_extents(fcb* fcb, PIRP Irp, LIST_ENTRY* rollback) {
+static void rationalize_extents(fcb* fcb, PIRP Irp) {
     LIST_ENTRY* le;
     LIST_ENTRY extent_ranges;
     extent_range* er;
     BOOL changed = FALSE, truncating = FALSE;
     UINT32 num_extents = 0;
-    
+
     InitializeListHead(&extent_ranges);
-    
+
     le = fcb->extents.Flink;
     while (le != &fcb->extents) {
         extent* ext = CONTAINING_RECORD(le, extent, list_entry);
-        
-        if ((ext->data->type == EXTENT_TYPE_REGULAR || ext->data->type == EXTENT_TYPE_PREALLOC) && ext->data->compression == BTRFS_COMPRESSION_NONE && ext->unique) {
-            EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->data->data;
-            
+
+        if ((ext->extent_data.type == EXTENT_TYPE_REGULAR || ext->extent_data.type == EXTENT_TYPE_PREALLOC) && ext->extent_data.compression == BTRFS_COMPRESSION_NONE && ext->unique) {
+            EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->extent_data.data;
+
             if (ed2->size != 0) {
                 LIST_ENTRY* le2;
-                
+
                 le2 = extent_ranges.Flink;
                 while (le2 != &extent_ranges) {
                     extent_range* er2 = CONTAINING_RECORD(le2, extent_range, list_entry);
-                    
+
                     if (er2->address == ed2->address) {
                         er2->skip_start = min(er2->skip_start, ed2->offset);
                         er2->skip_end = min(er2->skip_end, ed2->size - ed2->offset - ed2->num_bytes);
@@ -3775,16 +4311,16 @@
                         goto cont;
                     } else if (er2->address > ed2->address)
                         break;
-                    
+
                     le2 = le2->Flink;
                 }
-                
+
                 er = ExAllocatePoolWithTag(PagedPool, sizeof(extent_range), ALLOC_TAG); // FIXME - should be from lookaside?
                 if (!er) {
                     ERR("out of memory\n");
                     goto end;
                 }
-                
+
                 er->address = ed2->address;
                 er->length = ed2->size;
                 er->offset = ext->offset - ed2->offset;
@@ -3792,68 +4328,68 @@
                 er->chunk = NULL;
                 er->skip_start = ed2->offset;
                 er->skip_end = ed2->size - ed2->offset - ed2->num_bytes;
-                
+
                 if (er->skip_start != 0 || er->skip_end != 0)
                     truncating = TRUE;
-                
+
                 InsertHeadList(le2->Blink, &er->list_entry);
                 num_extents++;
             }
         }
-        
+
 cont:
         le = le->Flink;
     }
-    
+
     if (num_extents == 0 || (num_extents == 1 && !truncating))
         goto end;
-    
+
     le = extent_ranges.Flink;
     while (le != &extent_ranges) {
         er = CONTAINING_RECORD(le, extent_range, list_entry);
-        
+
         if (!er->chunk) {
             LIST_ENTRY* le2;
-            
+
             er->chunk = get_chunk_from_address(fcb->Vcb, er->address);
-            
+
             if (!er->chunk) {
                 ERR("get_chunk_from_address(%llx) failed\n", er->address);
                 goto end;
             }
-            
+
             le2 = le->Flink;
             while (le2 != &extent_ranges) {
                 extent_range* er2 = CONTAINING_RECORD(le2, extent_range, list_entry);
-                
+
                 if (!er2->chunk && er2->address >= er->chunk->offset && er2->address < er->chunk->offset + er->chunk->chunk_item->size)
                     er2->chunk = er->chunk;
-                
+
                 le2 = le2->Flink;
             }
         }
-        
+
         le = le->Flink;
     }
-    
+
     if (truncating) {
         // truncate beginning or end of extent if unused
-        
+
         le = extent_ranges.Flink;
         while (le != &extent_ranges) {
             er = CONTAINING_RECORD(le, extent_range, list_entry);
-            
+
             if (er->skip_start > 0) {
                 LIST_ENTRY* le2 = fcb->extents.Flink;
                 while (le2 != &fcb->extents) {
                     extent* ext = CONTAINING_RECORD(le2, extent, list_entry);
-                    
-                    if ((ext->data->type == EXTENT_TYPE_REGULAR || ext->data->type == EXTENT_TYPE_PREALLOC) && ext->data->compression == BTRFS_COMPRESSION_NONE && ext->unique) {
-                        EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->data->data;
-                
+
+                    if ((ext->extent_data.type == EXTENT_TYPE_REGULAR || ext->extent_data.type == EXTENT_TYPE_PREALLOC) && ext->extent_data.compression == BTRFS_COMPRESSION_NONE && ext->unique) {
+                        EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->extent_data.data;
+
                         if (ed2->size != 0 && ed2->address == er->address) {
                             NTSTATUS Status;
-                            
+
                             Status = update_changed_extent_ref(fcb->Vcb, er->chunk, ed2->address, ed2->size, fcb->subvol->id, fcb->inode, ext->offset - ed2->offset,
                                                                -1, fcb->inode_item.flags & BTRFS_INODE_NODATASUM, TRUE, Irp);
                             if (!NT_SUCCESS(Status)) {
@@ -3860,42 +4396,56 @@
                                 ERR("update_changed_extent_ref returned %08x\n", Status);
                                 goto end;
                             }
-                            
-                            ext->data->decoded_size -= er->skip_start;
+
+                            ext->extent_data.decoded_size -= er->skip_start;
                             ed2->size -= er->skip_start;
                             ed2->address += er->skip_start;
                             ed2->offset -= er->skip_start;
-                            
+
                             add_changed_extent_ref(er->chunk, ed2->address, ed2->size, fcb->subvol->id, fcb->inode, ext->offset - ed2->offset,
                                                    1, fcb->inode_item.flags & BTRFS_INODE_NODATASUM);
                         }
                     }
-                    
+
                     le2 = le2->Flink;
                 }
-                
+
                 if (!(fcb->inode_item.flags & BTRFS_INODE_NODATASUM))
-                    add_checksum_entry(fcb->Vcb, er->address, er->skip_start / fcb->Vcb->superblock.sector_size, NULL, NULL, rollback);
-                
-                decrease_chunk_usage(er->chunk, er->skip_start);
-                
-                space_list_add(fcb->Vcb, er->chunk, TRUE, er->address, er->skip_start, NULL);
-                
+                    add_checksum_entry(fcb->Vcb, er->address, (ULONG)(er->skip_start / fcb->Vcb->superblock.sector_size), NULL, NULL);
+
+                ExAcquireResourceExclusiveLite(&er->chunk->lock, TRUE);
+
+                if (!er->chunk->cache_loaded) {
+                    NTSTATUS Status = load_cache_chunk(fcb->Vcb, er->chunk, NULL);
+
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("load_cache_chunk returned %08x\n", Status);
+                        ExReleaseResourceLite(&er->chunk->lock);
+                        goto end;
+                    }
+                }
+
+                er->chunk->used -= er->skip_start;
+
+                space_list_add(er->chunk, er->address, er->skip_start, NULL);
+
+                ExReleaseResourceLite(&er->chunk->lock);
+
                 er->address += er->skip_start;
                 er->length -= er->skip_start;
             }
-            
+
             if (er->skip_end > 0) {
                 LIST_ENTRY* le2 = fcb->extents.Flink;
                 while (le2 != &fcb->extents) {
                     extent* ext = CONTAINING_RECORD(le2, extent, list_entry);
-                    
-                    if ((ext->data->type == EXTENT_TYPE_REGULAR || ext->data->type == EXTENT_TYPE_PREALLOC) && ext->data->compression == BTRFS_COMPRESSION_NONE && ext->unique) {
-                        EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->data->data;
-                
+
+                    if ((ext->extent_data.type == EXTENT_TYPE_REGULAR || ext->extent_data.type == EXTENT_TYPE_PREALLOC) && ext->extent_data.compression == BTRFS_COMPRESSION_NONE && ext->unique) {
+                        EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->extent_data.data;
+
                         if (ed2->size != 0 && ed2->address == er->address) {
                             NTSTATUS Status;
-                            
+
                             Status = update_changed_extent_ref(fcb->Vcb, er->chunk, ed2->address, ed2->size, fcb->subvol->id, fcb->inode, ext->offset - ed2->offset,
                                                                -1, fcb->inode_item.flags & BTRFS_INODE_NODATASUM, TRUE, Irp);
                             if (!NT_SUCCESS(Status)) {
@@ -3902,86 +4452,96 @@
                                 ERR("update_changed_extent_ref returned %08x\n", Status);
                                 goto end;
                             }
-                            
-                            ext->data->decoded_size -= er->skip_end;
+
+                            ext->extent_data.decoded_size -= er->skip_end;
                             ed2->size -= er->skip_end;
-                            
+
                             add_changed_extent_ref(er->chunk, ed2->address, ed2->size, fcb->subvol->id, fcb->inode, ext->offset - ed2->offset,
                                                    1, fcb->inode_item.flags & BTRFS_INODE_NODATASUM);
                         }
                     }
-                    
+
                     le2 = le2->Flink;
                 }
-                
+
                 if (!(fcb->inode_item.flags & BTRFS_INODE_NODATASUM))
-                    add_checksum_entry(fcb->Vcb, er->address + er->length - er->skip_end, er->skip_end / fcb->Vcb->superblock.sector_size, NULL, NULL, rollback);
-                
-                decrease_chunk_usage(er->chunk, er->skip_end);
-                
-                space_list_add(fcb->Vcb, er->chunk, TRUE, er->address + er->length - er->skip_end, er->skip_end, NULL);
-                
+                    add_checksum_entry(fcb->Vcb, er->address + er->length - er->skip_end, (ULONG)(er->skip_end / fcb->Vcb->superblock.sector_size), NULL, NULL);
+
+                ExAcquireResourceExclusiveLite(&er->chunk->lock, TRUE);
+
+                if (!er->chunk->cache_loaded) {
+                    NTSTATUS Status = load_cache_chunk(fcb->Vcb, er->chunk, NULL);
+
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("load_cache_chunk returned %08x\n", Status);
+                        ExReleaseResourceLite(&er->chunk->lock);
+                        goto end;
+                    }
+                }
+
+                er->chunk->used -= er->skip_end;
+
+                space_list_add(er->chunk, er->address + er->length - er->skip_end, er->skip_end, NULL);
+
+                ExReleaseResourceLite(&er->chunk->lock);
+
                 er->length -= er->skip_end;
             }
-            
+
             le = le->Flink;
         }
     }
-    
+
     if (num_extents < 2)
         goto end;
-    
+
     // merge together adjacent extents
     le = extent_ranges.Flink;
     while (le != &extent_ranges) {
         er = CONTAINING_RECORD(le, extent_range, list_entry);
-        
+
         if (le->Flink != &extent_ranges && er->length < MAX_EXTENT_SIZE) {
             extent_range* er2 = CONTAINING_RECORD(le->Flink, extent_range, list_entry);
-            
+
             if (er->chunk == er2->chunk) {
                 if (er2->address == er->address + er->length && er2->offset >= er->offset + er->length) {
                     if (er->length + er2->length <= MAX_EXTENT_SIZE) {
                         er->length += er2->length;
                         er->changed = TRUE;
-                        
+
                         RemoveEntryList(&er2->list_entry);
                         ExFreePool(er2);
-                        
+
                         changed = TRUE;
                         continue;
-//                     } else { // FIXME - make changing of beginning of offset work
-//                         er2->length = er2->address + er->length - er->address - MAX_EXTENT_SIZE;
-//                         er2->address = er->address + MAX_EXTENT_SIZE;
-//                         er->length = MAX_EXTENT_SIZE;
                     }
                 }
             }
         }
-        
+
         le = le->Flink;
     }
-    
+
     if (!changed)
         goto end;
-    
+
     le = fcb->extents.Flink;
     while (le != &fcb->extents) {
         extent* ext = CONTAINING_RECORD(le, extent, list_entry);
-        
-        if ((ext->data->type == EXTENT_TYPE_REGULAR || ext->data->type == EXTENT_TYPE_PREALLOC) && ext->data->compression == BTRFS_COMPRESSION_NONE && ext->unique) {
-            EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->data->data;
-            
+
+        if ((ext->extent_data.type == EXTENT_TYPE_REGULAR || ext->extent_data.type == EXTENT_TYPE_PREALLOC) && ext->extent_data.compression == BTRFS_COMPRESSION_NONE && ext->unique) {
+            EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->extent_data.data;
+
             if (ed2->size != 0) {
                 LIST_ENTRY* le2;
-                
+
                 le2 = extent_ranges.Flink;
                 while (le2 != &extent_ranges) {
                     extent_range* er2 = CONTAINING_RECORD(le2, extent_range, list_entry);
-                    
+
                     if (ed2->address >= er2->address && ed2->address + ed2->size <= er2->address + er2->length && er2->changed) {
                         NTSTATUS Status;
-                        
+
                         Status = update_changed_extent_ref(fcb->Vcb, er2->chunk, ed2->address, ed2->size, fcb->subvol->id, fcb->inode, ext->offset - ed2->offset,
                                                            -1, fcb->inode_item.flags & BTRFS_INODE_NODATASUM, TRUE, Irp);
                         if (!NT_SUCCESS(Status)) {
@@ -3988,36 +4548,36 @@
                             ERR("update_changed_extent_ref returned %08x\n", Status);
                             goto end;
                         }
-                        
+
                         ed2->offset += ed2->address - er2->address;
                         ed2->address = er2->address;
                         ed2->size = er2->length;
-                        ext->data->decoded_size = ed2->size;
-                        
+                        ext->extent_data.decoded_size = ed2->size;
+
                         add_changed_extent_ref(er2->chunk, ed2->address, ed2->size, fcb->subvol->id, fcb->inode, ext->offset - ed2->offset,
                                                1, fcb->inode_item.flags & BTRFS_INODE_NODATASUM);
-                        
+
                         break;
                     }
-                    
+
                     le2 = le2->Flink;
                 }
             }
         }
-        
+
         le = le->Flink;
     }
-    
+
 end:
     while (!IsListEmpty(&extent_ranges)) {
         le = RemoveHeadList(&extent_ranges);
         er = CONTAINING_RECORD(le, extent_range, list_entry);
-        
+
         ExFreePool(er);
     }
 }
 
-void flush_fcb(fcb* fcb, BOOL cache, LIST_ENTRY* batchlist, PIRP Irp, LIST_ENTRY* rollback) {
+NTSTATUS flush_fcb(fcb* fcb, BOOL cache, LIST_ENTRY* batchlist, PIRP Irp) {
     traverse_ptr tp;
     KEY searchkey;
     NTSTATUS Status;
